<template>
  <div class="container">
    <post-short v-for="post in paginatedPosts" :key="post.id + post.date_created"
                :id="post.id"
                :title="post.title"
                :author="post.author"
                :body="post.body"
                :numComments="post.num_comments"
                :numLikes="post.num_likes"
                :dateCreated="post.date_created"></post-short>
    <div class="text-center">
      <base-button button-type="pagination-expand-button" @click="increasePaginationStep" v-if="!maxPaginationStepReached">
        Load More
      </base-button>
    </div>
    <br>
  </div>
</template>

<script>
import PostShort from "@/components/blog/PostShort";
import BaseButton from "@/components/ui/BaseButton";
export default {
  name: "PostTimeline",
  components: {BaseButton, PostShort},
  data() {
    return {
      currentPaginationStep: 0,
      currentPaginationBatchSize: 3, // treat as constant
    }
  },
  computed: {
    paginatedPosts() {
      this.setPostPagination(this.currentPaginationBatchSize, this.currentPaginationStep); // initialize batch parameters in vuex
      return this.$store.getters['blog/getPaginatedPosts']; // getter returns correct batch
    },
    maxPaginationStepReached() {
      return this.currentPaginationBatchSize * (this.currentPaginationStep + 1) >= this.$store.getters['blog/getMaxPosts'];
    },
  },
  methods: {
    setPostPagination(paginationBatchSize, paginationStep) {
      // paginationBatch: # of posts to be loaded in each step
      // pagitationStep: # of current step starting @ zero
      // returns array of posts
      this.$store.commit({
        type: 'blog/setPaginationBatchSize',
        paginationBatchSize: paginationBatchSize,
      });
      this.$store.commit({
        type: 'blog/setPaginationBatchCurrent',
        paginationStep: paginationStep,
      });
    },
    increasePaginationStep() {
      this.currentPaginationStep += 1;
    }
  },
  beforeMount() {
    // restore pagination settings to default
    this.currentPaginationStep = 0;
  }
}
</script>

<style scoped>
</style>
